﻿// <copyright file="SecurityService.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 10-06-2011 All Right Reserved
// </copyright>
// <author>Anuj Varma</author>
// <date>10-06-2011</date>
// <summary>Class representing a SecurityService.cs entity.</summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Services_Architecture.ServicesByFeature
{
    public class SecurityService : ISecurityService 
    {
        public void AuthenticateUser()
        {

            //  common code - example - Initialize
            Console.WriteLine("Security Service: Common Initialize Code");

            // Platform specific code
            SomePlatformSpecificOperation(); // example - authenticate against sqlserver

            // common code again - example - cleanup()...
            Console.WriteLine("Security Service: Common Cleanup Code");
        }

        protected virtual void SomePlatformSpecificOperation()
        {
            Console.WriteLine("Some base operation that is common to Oracle Security and SqlServer security");
        }
    }
}
